var lpfunc = {
    openedWins : [],
    targetLmn : null,

    init : function(event) {
        document.getElementById('contentAreaContextMenu').addEventListener('popupshowing', function(event){
            document.getElementById('lmnpop-ctxmnu').setAttribute('hidden', !lpfunc.pget('contextmenu'));
        }, false);

        gBrowser.addEventListener("DOMContentLoaded", function(event){
            var htmlDocument = event.originalTarget;
            var view = htmlDocument.defaultView;
            if (! htmlDocument instanceof HTMLDocument || !view || view.top != view
                || !lpfunc.pget('videobutton')) {
                return;
            }

            var videobtn;

            htmlDocument.addEventListener('mouseover', function(ev) {
                var lmn = ev.originalTarget;
                if (lmn instanceof HTMLEmbedElement || lmn instanceof HTMLObjectElement) {
                    lpfunc.targetLmn = lmn;
                    lpfunc.targetLmn.addEventListener('mouseout', function() {
                        videobtn.style.opacity = 0;
                        this.removeEventListener("mouseout", arguments.callee, false);
                    }, false);

                    if (!videobtn) {
                        videobtn = lpfunc.addVideoBtn(htmlDocument);
                    }
                    var rect = lmn.getBoundingClientRect();
                    videobtn.style.left = rect.left + rect.width + 'px';
                    videobtn.style.top  = rect.top + 'px';
                    videobtn.style.opacity = 1;
                }
            }, false);
        }, false);
    },

    openVideoDlg : function(lmn, vnt) {
        if (!lmn || !lmn instanceof Node) {
            return;
        }

        var args = [];
        var lite = lpfunc.pget('winlite');
        args['ontop'] = lpfunc.pget('ontop') ^ vnt.shiftKey;
        args['rect'] = lmn.getBoundingClientRect();
        args['toolboxcolor'] = lpfunc.pget('toolboxcolorused') ? lpfunc.pget('toolboxcolor') : false;
        args['allowmove'] = lpfunc.pget('allowmove');
        args['element'] = lmn.cloneNode(true);
        args['lite'] = lite;
        args.wrappedJSObject = args;

        var sgn = lpfunc.pget('singleton');
        var cls = lpfunc.pget( 'close') ^ vnt.ctrlKey;
        var cln = lpfunc.pget( 'clone');
        var id = "lmnpop_" + new Date().getTime();
        
        if (!cls && !cln) {
            lpfunc.blockVideo(lmn, id);
        }
        if(sgn && lpfunc.openedWins.length > 0) {
            for (var i=0; i<lpfunc.openedWins.length; ++i)
                lpfunc.openedWins[i].close();
            lpfunc.openedWins.length = 0;
        }

        lpfunc.openedWins.push(openDialog('chrome://lmnpop/content/lmnpop.xul', id,
            'resizable,dialog=no,scrollbars=no' + (lite ? ',titlebar=no' : ''), args));
        if(cls)
            gBrowser.removeCurrentTab();
    },

    addVideoBtn : function(doc) {
        var videobtn = doc.createElement('img');
        videobtn.id = 'lp_video_button';
        videobtn.title = 'Click here to popup video';
        videobtn.addEventListener('mouseover', function() {
            this.style.opacity = 1;
        }, false);
        videobtn.addEventListener('mouseout', function() {
            this.style.opacity = 0;
        }, false);
        videobtn.addEventListener('click', function(event){
            this.style.left = '-100px';
            this.style.top  = '-100px';
            lpfunc.openVideoDlg(lpfunc.targetLmn, event);
        }, false);
        videobtn.style.cssText = 'width: 18px; height: 18px; z-index: 9999;\
                border-style: none; cursor: pointer; \
                background: url("chrome://lmnpop/skin/videobtn.png") no-repeat center;\
                position:fixed; left:-100px; top:-100px; opacity:0;\
                -moz-transition-property: opacity; -moz-transition-duration: 0.5s; -moz-transition-timing-function: linear;';
        doc.body.appendChild(videobtn);
        return videobtn;
    },

    blockVideo : function(lmn, id) {
        if (lmn.parentNode.nodeName.toLowerCase() == 'object') {
            lmn = lmn.parentNode;
        }
        var block = document.createElement('div');
        block.id = id;
        block.style.cssText = 'border-style: none; cursor: pointer; \
                background: url("chrome://lmnpop/skin/icon-64.png") no-repeat center;';
        var rect = lmn.getBoundingClientRect();
        block.style.width = (rect.width > 64 ? rect.width : 64) + 'px';
        block.style.height = (rect.height > 64 ? rect.height : 64) + 'px';
        block.onclick = function (e) {
            e.target.parentNode.removeChild(e.target);
            lmn.style.display = "block";
            //Close popup window
            for(var i=0; i<lpfunc.openedWins.length; ++i){
                if(lpfunc.openedWins[i].name == id) {
                    lpfunc.openedWins[i].close();
                }
            }
        };
        lmn.parentNode.insertBefore(block, lmn);
        lmn.style.display = "none";
    },

    fill : function lp_fill(mp){
        var bsp = lpfunc.pget('blink.speed');
        var bst = bsp > 0 && lpfunc.pget('blink.style');
        var lms = lpfunc.pick(lpfunc.pget('xpath')), fmt = lpfunc.pget('format');
        lms.forEach(function(lmn){
            var mi = menuitem({
                label: lpfunc.format(lmn, fmt),
                crop: 'center',
                oncommand: 'lpfunc.openVideoDlg(this.lmn, event)'
            });
            mi.lmn = lmn;
            bst && mi.addEventListener('DOMMenuItemActive', blink, false);
        });
        if(lms.length){
            mp.appendChild(document.createElement('menuseparator'));
            if(lms.length > 1){
                menuitem({
                    label: 'Pop All',
                    accesskey: 'A',
                    oncommand: 'this.lms.forEach(function(lm) lpfunc.openVideoDlg(lm, event))'
                }).lms = lms;
            }
        }
        menuitem({
            label: 'Options',
            accesskey: 'O',
            oncommand: "openDialog('chrome://lmnpop/content/lpo.xul', 'lpo', 'resizable=no').focus();"
        });

        function blink(){
            var lmn = this.lmn, stl = lmn.style, i = 6;
            setTimeout(function loop(){
                if (--i < 0) {
                    return;
                }
                else {
                    setTimeout(loop, bsp);
                    stl.outline = (i & 1 == 1) ? bst : 'none';
                }
            }, 0);
            lmn.scrollIntoView(false);
        }
        function menuitem(atrs){
            var mi = document.createElement('menuitem');
            for(var k in atrs) mi.setAttribute(k, atrs[k]);
            return mp.appendChild(mi);
        }
    },

    pick : function lp_pick(xpath){
        var lms = [];
        var doc = document.commandDispatcher.focusedWindow.document;
        var els = doc.evaluate(xpath, doc, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
        for (var j = 0; j < els.snapshotLength; ++j) {
            var lm = els.snapshotItem(j);
            if (lm.style.display != 'none' && lm.parentNode.style.display != 'none')
                lms.push(lm);
        }
        return lms;
    },

    pget : function  lp_pget(key){
        const PS = gPrefService;
        switch(PS.getPrefType(key = 'extensions.lmnpop.'+ key)){
            case PS.PREF_STRING:
                return PS.getComplexValue(key, Ci.nsISupportsString).data;
            case PS.PREF_BOOL:
                return PS.getBoolPref(key);
            case PS.PREF_INT :
                return PS.getIntPref(key);
        }
    },

    format : function lp_format(lmn, fmt){
        return (fmt || lpfunc.pget('format')).replace(/{.+?}/g, function($){
            for(let [, k] in new Iterator($.slice(1, -1).split('|'))){
                let v = lmn[k];
                if(v)
                    return String(v).replace(/^http:.*\/(.*)/, '$1').split('?')[0];
            }
            return '';
        });
    }
};

window.addEventListener('load', lpfunc.init, false);

