var lmnpop = {
    url : "",
    hWnd : null,
    toolbox : null,
    moving : false,
    movingElement : null,
    clientWidth : 600,
    clientHeight : 450,
    clickClientX : 0,
    clickClientY : 0,

    init : function () {
        var repaintTimeout = 500;
        var lmn;
        var ontop,tbc,lite;
        if (window.arguments.length < 1) {
            return;
        }

        var args = window.arguments[0].wrappedJSObject;
        lmn = args['element'];
        ontop = args['ontop'];
        tbc = args['toolboxcolor'];
        lite = args['lite'];
        lmnpop.url = lmn.ownerDocument.URL;
        //Adjust client size
        lmnpop.clientWidth = args['rect'].width;
        lmnpop.clientHeight = args['rect'].height;
        if (lmnpop.url.indexOf('www.tudou.com') != -1) {
            repaintTimeout = 1500;
            if (lmnpop.clientHeight < 500)
                lmnpop.clientWidth = 600;
        } else if (lmnpop.url.indexOf('v.163.com') != -1) {
            lmnpop.clientWidth = 600;
            lmnpop.clientHeight = 481;
        }

        //tool box for Firefox 4
        lmnpop.toolbox = document.getElementById('lp-toolbox');
        lmnpop.toolbox.setAttribute('topmost', false);
        if(tbc) lmnpop.toolbox.style.backgroundColor = tbc;
        lmnpop.alwaysOnTop(ontop ? true : false);

        //lite window
        lmnpop.toolbox.setAttribute('titlebar', lite ? 'yes' : 'no');
        if (lite) {
            lmnpop.toolbox.setAttribute('sizemode', 'normal');
            var minBtn = document.getElementById('lp-min');
            minBtn.style.marginLeft = (window.innerWidth - 155) + 'px';
            window.onresize = function () {
                minBtn.style.marginLeft = (window.innerWidth - 155) + 'px';
            }
        }

        //Allow move in window
        if(args['allowmove']) {
            lmnpop.movingElement = window;
            lmnpop.movingElement.addEventListener("mousedown", lmnpop.msdown, false);
        } else if(lite) {
            lmnpop.movingElement = lmnpop.toolbox;
            lmnpop.movingElement.addEventListener("mousedown", lmnpop.msdown, false);
        }

        //tool menu for Firefox 3.6 and later
        var menu = document.getElementById('lp-menu');
        window.addEventListener ("keydown", function menupop(vnt){
            if (vnt.altKey) {
                menu.childNodes[0].setAttribute("checked", lmnpop.isOnTop());
                menu.openPopup(null, "after_end", 0, 0, false, false);
            }
        }, false);

        //set browser
        var browser = document.getElementById('lp-browser');
        if (lmnpop.toLoadUrl(lmn)) {
            browser.setAttribute('src', lmnpop.url);
            browser.addEventListener('DOMTitleChanged', function lmnssset(event){
                var doc = window.content.document;
                var link = doc.createElement("link");
                link.setAttribute("rel", "stylesheet");
                link.setAttribute("type", "text/css");
                link.setAttribute("href", "chrome://lmnpop/skin/lpbrowser.css");
                doc.head.appendChild(link);
            }, false);
        } else {
            browser.setAttribute('src', 'data:text/html,<!--lmnpop-->'+ encodeURI(<base href={lmn.baseURI}/>.toXMLString()));
        }
        
        browser.addEventListener('DOMContentLoaded', function lmnset(event){
            var doc = event.originalTarget;
            var view = doc.defaultView;
            if (! doc instanceof HTMLDocument || !view || view.top != view)
                return;

            var htm = doc.documentElement;
            var body = doc.body;
            htm.setAttribute('style', 'height:100%;');
            body.setAttribute('style', 'margin:0;');
            body.style.display = 'none';

            //Append and refresh video
            var video = lmnpop.toLoadUrl(lmn) ? lmnpop.setVideoLoaded(lmn, doc) : lmnpop.setVideoPopped(lmn);
            video.setAttribute('style', 'margin:0;width:100%;height:99%;display:block;overflow:auto;');
            video.setAttribute('wmode', 'transparent');
            video.setAttribute("classid", "java:lmnpop");     //without flashblock
            video = htm.appendChild(doc.adoptNode(video));
            window.setTimeout(function(){
                video.style.height = "100%";
            }, repaintTimeout);
        }, true);
    },

    toLoadUrl : function(lmn) {
        return lmn.id != '' && /v\.youku\.com|v\.qq\.com|tv\.sohu\.com|www\.qiyi\.com/i.test(lmnpop.url);
    },

    setVideoLoaded : function(lmn, doc) {
        document.title = doc.title;
        lmnpop.toolbox.setAttribute('tooltiptext', document.title);
        lmnpop.url = doc.URL;
        var video;
        if (lmn.id != '') {
            video = doc.getElementById(lmn.id);
        } else {
            var lms = doc.getElementsByTagName(lmn.tagName);
            if (lms.length > 0) {
                video = lms[0];
            }
        }

        if (!video) {
            video = lmn;
        }

        return lmnpop.object2embed(video);
    },

    setVideoPopped : function(lmn) {
        var doc = lmn.ownerDocument;
        document.title = doc.title;
        lmnpop.toolbox.setAttribute('tooltiptext', document.title);
        lmnpop.url = doc.URL;

        lmn = lmnpop.object2embed(lmn);
        var src = lmn.getAttribute('src');
        var matches;
        if (src.indexOf("http://js.tudouui.com/bin/player_online/TudouVideoPlayer_Homer") != -1) {
            //To process the side advertisement swf of Tudou.com
            if (matches = lmnpop.url.match(/^http:\/\/www\.tudou\.com\/programs\/view\/(.{11})/)){
                lmn.setAttribute('src', 'http://www.tudou.com/v/' + matches[1] + '/v.swf');
                lmn.setAttribute('flashvars', 'autoPlay=true');
            } else if ((matches = lmn.getAttribute('flashvars').match(/(iid=(\d+)&lid=(\d+))&uid.*/)) && matches[3] != '0'){
                lmn.setAttribute('src', 'http://www.tudou.com/l/' + matches[3] + '/&iid=' + matches[2] + '/v.swf');
                lmn.setAttribute('flashvars', 'autoPlay=true');
            }
        } else if (src.indexOf("http://img1.cache.netease.com/v/player/OlyVPlayer") != -1)  {
            //To process the 163 video
            if (matches = lmnpop.url.match(/http:\/\/v\.163\.com\/video\/.*\/(\w+)\.html/)) {
                lmn.setAttribute('src', 'http://img1.cache.netease.com/flvplayer081128/~true~0085_' + matches[1] + '~.swf');
            }
        }
        else if (src.indexOf("http://player.ku6cdn.com/default/insite/swf/") != -1) {
            //To process the outside swf of ku6.com
            if (matches = lmn.getAttribute('flashvars').match(/vid=(.*)/)){
                lmn.setAttribute('src', 'http://player.ku6.com/refer/' + matches[1] + '/v.swf&auto=1');
            }
        }
        else if (src.indexOf("http://p.you.video.sina.com.cn/swf/bokePlayer") != -1) {
            //To process the sina video
            var pic = doc.querySelector("li[class~='cur'] img");
            if (matches = pic.getAttribute('src').match(/http:\/\/.*\/(\d+_\d+)\.jpg/)) {
                lmn.setAttribute('src', 'http://you.video.sina.com.cn/api/sinawebApi/outplayrefer.php/vid=' + matches[1] + '&autoPlay=1/s.swf');
                lmn.setAttribute('flashvars', '');
            }
        } else if (src.indexOf("http://client.joy.cn/flvplayer/joyplayer.swf") != -1) {
            //To process joy.cn
            var elm = doc.querySelector("meta[property='og:videosrc']");
            if (elm && elm.content) {
                lmn.setAttribute('src', elm.content.replace("1_0_1", "1_2_1"));
            }
        }
        return lmn;
    },

    object2embed: function (lmn) {
        if (lmn.tagName.toUpperCase() != 'OBJECT') {
            return lmn;
        }

        var embed;
        var ownerDoc = lmn.ownerDocument;
        var children = lmn.childNodes;
        for(var j=0; j<children.length; ++j) {
            if (children[j].tagName.toUpperCase() == 'EMBED') {
                embed = children[j].cloneNode(true);
            }
        }

        if (!embed) {
            embed = ownerDoc.createElement('embed');
            var attrs = lmn.childNodes;
            for(var i=0; i<attrs.length; ++i) {
                embed.setAttribute(attrs[i].getAttribute('name'), attrs[i].getAttribute('value'));
            }
            embed.setAttribute('type', "application/x-shockwave-flash");
            embed.setAttribute('src', lmn.getAttribute('data'));
        }

        if (embed.id == '') {
            embed.id = (lmn.id == '' ? 'lmnPlayer' : lmn.id);
        }

        return embed;
    },

    msdown : function(vnt) {
        if (vnt.button == 0 && vnt.clientY < window.innerHeight - 40) {
            lmnpop.moving = true;
            lmnpop.clickClientX = vnt.screenX - window.screenX;
            lmnpop.clickClientY = vnt.screenY - window.screenY;
            lmnpop.movingElement.addEventListener("mousemove", lmnpop.msmove, false);
            lmnpop.movingElement.addEventListener("mouseup", lmnpop.msup, false);
        }
    },

    msmove : function(vnt) {
        if (lmnpop.moving) {
            window.moveTo(vnt.screenX - lmnpop.clickClientX, vnt.screenY - lmnpop.clickClientY);
        }
    },

    msup : function(vnt) {
        lmnpop.moving = false;
        lmnpop.movingElement.removeEventListener("mousemove", lmnpop.msmove, false);
        lmnpop.movingElement.removeEventListener("mouseup", lmnpop.msup, false);
    },

    oriSize : function() {
        window.innerWidth = lmnpop.clientWidth;
        window.innerHeight = lmnpop.clientHeight;
    },

    restoreTab : function() {
        var gBrowser = window.opener.gBrowser;
        if (gBrowser) {
            var num = gBrowser.browsers.length;
            var found = false;
            for (var i = 0; i < num; i++) {
                var doc = gBrowser.getBrowserAtIndex(i).contentDocument;
                var blockNode;
                if (lmnpop.url == doc.URL && (blockNode=doc.getElementById(window.name))) {
                    gBrowser.selectedTab = gBrowser.tabContainer.childNodes[i];
                    blockNode.click();
                    found = true;
                    break;
                }
            }

            if (!found) {
                gBrowser.selectedTab = gBrowser.addTab(lmnpop.url);
                window.close();
            }
        } else {
            window.open(lmnpop.url);
            window.close();
        }
    },

    isOnTop : function() {
        return lmnpop.toolbox.getAttribute('topmost') == 'true';
    },

    alwaysOnTop : function(topMost) {
        if (lmnpop.isOnTop() == topMost)
            return;

        try {
            Components.utils.import("resource://gre/modules/ctypes.jsm");
            var lib = ctypes.open("user32.dll");
            if (!lmnpop.hWnd) {
                var funcFindWindow = 0;
                try
                {
                    funcFindWindow = lib.declare("FindWindowW",
                        ctypes.winapi_abi,
                        ctypes.int32_t,
                        ctypes.jschar.ptr,
                        ctypes.jschar.ptr);
                }
                catch (ex)
                {
                    funcFindWindow = lib.declare("FindWindowW",
                        ctypes.stdcall_abi,
                        ctypes.int32_t,
                        ctypes.jschar.ptr,
                        ctypes.jschar.ptr);
                }

                if (funcFindWindow != 0)
                {
                    lmnpop.hWnd = funcFindWindow("MozillaWindowClass", document.title);
                }
            }

            var funcSetWindowPos = 0;
            try
            {
                funcSetWindowPos = lib.declare("SetWindowPos",
                    ctypes.winapi_abi,
                    ctypes.bool,
                    ctypes.int32_t,
                    ctypes.int32_t,
                    ctypes.int32_t,
                    ctypes.int32_t,
                    ctypes.int32_t,
                    ctypes.int32_t,
                    ctypes.uint32_t);
            }
            catch(ex)
            {
                funcSetWindowPos = lib.declare("SetWindowPos",
                    ctypes.stdcall_abi,
                    ctypes.bool,
                    ctypes.int32_t,
                    ctypes.int32_t,
                    ctypes.int32_t,
                    ctypes.int32_t,
                    ctypes.int32_t,
                    ctypes.int32_t,
                    ctypes.uint32_t);
            }

            var hwndAfter = -2;
            if (topMost)
                hwndAfter = -1;

            funcSetWindowPos(lmnpop.hWnd, hwndAfter, 0, 0, 0, 0, 19);
            lib.close();
            lmnpop.toolbox.setAttribute('topmost', topMost);
        } catch (ex) {
            alert(ex);
        }
    },

    winMin : function() {
        lmnpop.toolbox.setAttribute('topmost', false);
        window.minimize();
    },

    winMax : function() {
        lmnpop.toolbox.setAttribute('sizemode', 'maximized');
        window.maximize();
    },

    winNormal : function() {
        lmnpop.toolbox.setAttribute('sizemode', 'normal');
        window.restore();
    },

    winClose : function() {
        window.close();
    }
};

window.addEventListener('load', lmnpop.init, false);
